/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Bildquellen;

import bilderAuswahl.ThreadBilderAuswahl;
import ffeststeuerungneu.Log;
import java.io.IOException;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.nio.file.Paths;
import static java.nio.file.StandardWatchEventKinds.ENTRY_CREATE;
import static java.nio.file.StandardWatchEventKinds.ENTRY_DELETE;
import static java.nio.file.StandardWatchEventKinds.ENTRY_MODIFY;
import java.nio.file.WatchEvent;
import java.nio.file.WatchKey;
import java.nio.file.WatchService;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Rino
 */
public class SnapchatBilder extends Thread{

    private ThreadBilderAuswahl tba;
    private WatchService watcher;
    private String SNAPCHAT; // = "C:\\ffestData\\instagram\\4K Stogram\\mvö_tag";
    private boolean runnable =true;

    public SnapchatBilder(ThreadBilderAuswahl tba, String pfad) {

        SNAPCHAT = pfad;

        this.tba = tba;

        try {
            watcher = FileSystems.getDefault().newWatchService();
            Path dir = Paths.get(SNAPCHAT);
            dir.register(watcher, ENTRY_CREATE, ENTRY_DELETE, ENTRY_MODIFY);
        } catch (IOException ex) {
            Logger.getLogger(Bildquellen.InstagramBilder.class.getName()).log(Level.SEVERE, null, ex);
            Log.setError(ex, "Class: InstagramBilder. File not found");
        }
    }

    @Override
    public void run() {
        while (!isInterrupted()) {
            WatchKey key;
            try {
                // wait for a key to be available
                key = watcher.take();
            } catch (InterruptedException ex) {
                Log.setError(ex, "Class: InstagramBilder Interrupt of Thread");
                return;
            }

            for (WatchEvent<?> event : key.pollEvents()) {
                // get event type
                WatchEvent.Kind<?> kind = event.kind();

                // get file name
                @SuppressWarnings("unchecked")
                WatchEvent<Path> ev = (WatchEvent<Path>) event;
                Path fileName = ev.context();

                if (fileName.toString().endsWith("jpg") && kind.equals(ENTRY_CREATE)) {
                    Log.incSnapchat();
                    tba.neuesBild(SNAPCHAT + "\\" + fileName.toString());
                    Log.setInfo("Image detected: Snapchat");
                }

                if (kind == ENTRY_CREATE) {
                    // process create event
                } else if (kind == ENTRY_DELETE) {
                    // process delete event
                } else if (kind == ENTRY_MODIFY) {
                    // process modify event
                }
            }

            // IMPORTANT: The key must be reset after processed
            boolean valid = key.reset();
            if (!valid) {
                break;
            }
        }

    }
    
    public void terminate(){
        runnable = false;
    }
}
