package Diashow;

import ffeststeuerungneu.Props;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.Timer;

public class AnzeigeDiashow extends JPanel {

    /**
     * Creates new form PDiashow
     */
    private int anzahlBilder = 20;
    private int neueBilderArray = 0;
    private int bildNr = 0;

    private static final int INSTAGRAM = 0;
    private static final int SNAPCHAT = 1;
    private static final int WHATSAPP = 2;

    private Timer t;

    private final ImageIcon icon[] = new ImageIcon[3];
    private BufferedImage bim[] = new BufferedImage[anzahlBilder];
    private BufferedImage neueBilder[] = new BufferedImage[99];

    private final Props p;

    private final String pfad;

    private boolean pause = false, fertig = false;

    private double fx, fy;
    private int width, height;

    public AnzeigeDiashow() {

        p = new Props();
        pfad = p.getInfo("resources");
        initIcon();
        initComponents();

        fertig = true;
    }

    private void initIcon() {
        icon[INSTAGRAM] = new ImageIcon(pfad + "instagram.png");
        icon[SNAPCHAT] = new ImageIcon(pfad + "snapchat.png");
        icon[WHATSAPP] = new ImageIcon(pfad + "whatsapp.png");

        for (int j = 0; j < icon.length; j++) {
            icon[j].setImage(icon[j].getImage().getScaledInstance(100, 100, Image.SCALE_DEFAULT));

        }
    }

    @Override
    public void paintComponent(Graphics g) {

        width = this.getWidth();
        height = this.getHeight() - this.panelText.getHeight();

//        this.setPreferredSize(new Dimension(200,400));
        g.setColor(Color.black);
        g.fillRect(0, 0, this.getWidth(), this.getHeight() + 40);

        if (bim[bildNr] != null && fertig) {
            fx = ((double) width / bim[bildNr].getWidth());
            fy = ((double) height / bim[bildNr].getHeight());

            if (pause) {

            } else if (fx > fy) {
                g.drawImage(bim[bildNr],
                        (int) ((width - (bim[bildNr].getWidth() * fy)) / 2),
                        (int) ((height - (bim[bildNr].getHeight() * fy)) / 2) + this.panelText.getHeight(),
                        (int) (bim[bildNr].getWidth() * fy),
                        (int) (bim[bildNr].getHeight() * fy), panelBild);
            } else {
                g.drawImage(bim[bildNr],
                        (int) ((width - (bim[bildNr].getWidth() * fx)) / 2),
                        (int) ((height - (bim[bildNr].getHeight() * fx)) / 2),
                        (int) (bim[bildNr].getWidth() * fx),
                        (int) (bim[bildNr].getHeight() * fx), panelBild);
            }
        }
    }

    private void naechstesBild() {
        bildNr++;
        if (bildNr >= anzahlBilder || bim[bildNr] == null) {
            bilderEinfuegen();
            bildNr = 0;
        }

        super.repaint();
    }

    public void bilderEinfuegen() {
        for (int i = 0; i < neueBilderArray; i++) {
            for (int j = bim.length - 1; j > 0; j--) {
                bim[j] = bim[j - 1];
            }
            bim[0] = neueBilder[i];
        }
        neueBilderArray = 0;
    }

    public void neuesBild(BufferedImage nbim) {
        neueBilder[neueBilderArray] = nbim;
        neueBilderArray++;
    }

    public void stop() {
        t.stop();
    }

    public void pause() {
        pause = !pause;
        repaint();
    }

    public void start() {
        t = new Timer(1000, new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                if (!pause) {
                    naechstesBild();
                }
            }

        });

        t.start();
    }

    public void setSek(int sec) {

        t.setDelay(sec * 1000);
        t.restart();
    }

    public void setAnzahlBilder(int a) {
        anzahlBilder = a;
    }

    public void weiter() {
        naechstesBild();
    }

    public void setAnzahl(int a) {
        anzahlBilder = a;
    }

    private void initComponents() {
        initText();

//
        panelText = new JPanel();
        panelText.setBackground(Color.black);
        
        
        
        panelText.add(labelInstagram);
        panelText.add(new JLabel("     "));
        panelText.add(labelSnapchat);
        panelText.add(new JLabel("     "));
        panelText.add(labelWhatsapp);
        
        this.setLayout(new BorderLayout());
//
        this.add(panelText, BorderLayout.NORTH);
    }

    private void initText() {
        labelWhatsapp = new JLabel(p.getInfo("whatsappnummer"));
        labelSnapchat = new JLabel(p.getInfo("snapchatname"));
        labelInstagram = new JLabel(p.getInfo("instagramtag"));

        labelWhatsapp.setIcon(icon[WHATSAPP]);
        labelSnapchat.setIcon(icon[SNAPCHAT]);
        labelInstagram.setIcon(icon[INSTAGRAM]);

        labelSnapchat.setForeground(Color.white);
        labelInstagram.setForeground(Color.white);
        labelWhatsapp.setForeground(Color.white);

        labelSnapchat.setFont(new java.awt.Font("Tahoma", 1, 48));
        labelInstagram.setFont(new java.awt.Font("Tahoma", 1, 48));
        labelWhatsapp.setFont(new java.awt.Font("Tahoma", 1, 48));

        labelWhatsapp.setVisible(false);
        labelInstagram.setVisible(false);
        labelSnapchat.setVisible(false);

    }

    public void setOnline(int what, boolean online) {
        switch (what) {
            case SNAPCHAT:
                labelSnapchat.setVisible(online);
                break;
            case INSTAGRAM:
                labelInstagram.setVisible(online);
                break;
            case WHATSAPP:
                labelWhatsapp.setVisible(online);
                break;
        }
    }

    private JPanel panelText;
    private JPanel panelBild;

    private JLabel labelWhatsapp;
    private JLabel labelInstagram;
    private JLabel labelSnapchat;
}
