/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package bilderAuswahl;

import ffeststeuerungneu.Anzeige;
import ffeststeuerungneu.Log;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Transparency;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.Timer;

/**
 *
 * @author Rino
 */
public class AnzeigeAuswahlbild extends javax.swing.JPanel {

    /**
     * Creates new form Auswahlbild
     */
    private static final int RIGHT = 0;
    private static final int LEFT = 1;

    private double fx, fy;
    private Timer t;
    private Anzeige gui;
    private BufferedImage rot, bim, NoImages;
    private Archiv archiv;
    private boolean erlaubt = false;

    private AffineTransform affineTransform;
    private BufferedImage rotatedImage;
    private Graphics2D g;

    private Anzeige a;

    private List<String> pfad = new ArrayList();

    int RotAngle = 0;

    public AnzeigeAuswahlbild(String pfad, String iconPfad, Anzeige a) {
        this.a = a;
        archiv = new Archiv(pfad);
        initData(pfad);
        
        
        try {
            NoImages = ImageIO.read(new File(iconPfad + "NoImage.png"));
            
//            NoImages = ImageIO.read(this.getClass().getResourceAsStream(iconPfad + "NoImage.png"));
        } catch (IOException ex) {
            Logger.getLogger(AnzeigeAuswahlbild.class.getName()).log(Level.SEVERE, null, ex);
        }
        bim = NoImages;
        initComponents();

        t = new Timer(500, new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent ae) {
                neuesBild();
            }

        });

        t.start();
    }

    private void initData(String pfad) {
        checkDir(pfad);
        checkDir(pfad + "archiv");
        checkDir(pfad + "archiv\\gut");
        checkDir(pfad + "archiv\\müll");

        Calendar cal = Calendar.getInstance();
        SimpleDateFormat sdf = new SimpleDateFormat("HH_mm_ss");

        checkDir(pfad + "archiv\\müll\\" + sdf.format(cal.getTime()));
        checkDir(pfad + "archiv\\gut\\" + sdf.format(cal.getTime()));

    }

    private boolean checkDir(String dirName) {
        File stats = new File(dirName);
        if (stats.exists() && stats.isDirectory()) // Überprüfen, ob es den Ordner gibt
        {
            return true;
        } else {
            return stats.mkdir(); // Erstellen des Ordners
        }
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);

        g.setColor(Color.black);
        g.fillRect(0, 0, this.getWidth(), this.getHeight());

        fx = ((double) this.getWidth() / bim.getWidth());
        fy = ((double) this.getHeight() / bim.getHeight());

        if (fx > fy) {
            g.drawImage(bim, (int) ((this.getWidth() - (bim.getWidth() * fy)) / 2),
                    (int) ((this.getHeight() - (bim.getHeight() * fy)) / 2),
                    (int) (bim.getWidth() * fy), (int) (bim.getHeight() * fy), this);
        } else {
            g.drawImage(bim, (int) ((this.getWidth() - (bim.getWidth() * fx)) / 2),
                    (int) ((this.getHeight() - (bim.getHeight() * fx)) / 2),
                    (int) (bim.getWidth() * fx), (int) (bim.getHeight() * fx), this);
        }
    }

    public void neuesBild() {

        if (pfad.size() > 0 && !erlaubt) {
            try {
                a.setButtons(true);
                a.sleepThreads();
                bim = ImageIO.read(new File(pfad.get(0)));
                pfad.remove(0);
                erlaubt = true;
                rot = bim;
            } catch (IOException ex) {
                Logger.getLogger(AnzeigeAuswahlbild.class.getName()).log(Level.SEVERE, null, ex);
                Log.setError(ex, "Class: AnzeigeAuswahlbilde<. NeuesBild einlesen failed");
            }
        } else if (!(pfad.size() > 0) && !erlaubt) {
            bim = NoImages;
            a.setButtons(false);
        }

//        if (tba.checkImage() && !erlaubt) {
//            bim = tba.getImage();
//            erlaubt = true;
//            rot = bim;
//        } else if (!tba.checkImage() && !erlaubt) {
//            bim = NoImages;
//        }
        repaint();
    }

    public void addPath(String p) {
        pfad.add(p);
    }

    public void verarbeite(boolean gut) {

        if (erlaubt) {
            erlaubt = false;

            if (gut) {
                archiv.bildInArchiv(bim);
                gui.uebergebeBild(bim);
            } else {
                archiv.bildInMuell(bim);
            }
            this.neuesBild();
        } else {
            bim = NoImages;
        }

    }

    public void rotate(int angle) {

        bim = rotateImage(bim, Math.toRadians(angle));
        repaint();

    }

    public BufferedImage rotateImage(BufferedImage image, double angle) {
        double sin = Math.abs(Math.sin(angle)), cos = Math.abs(Math.cos(angle));
        int w = image.getWidth(), h = image.getHeight();
        int neww = (int) Math.floor(w * cos + h * sin), newh = (int) Math.floor(h * cos + w * sin);
        GraphicsConfiguration gc = getDefaultConfiguration();
        BufferedImage result = gc.createCompatibleImage(neww, newh, Transparency.TRANSLUCENT);
        Graphics2D g = result.createGraphics();
        g.translate((neww - w) / 2, (newh - h) / 2);
        g.rotate(angle, w / 2, h / 2);
        g.drawRenderedImage(image, null);
        g.dispose();
        return result;
    }

    private GraphicsConfiguration getDefaultConfiguration() {
        GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
        GraphicsDevice gd = ge.getDefaultScreenDevice();
        return gd.getDefaultConfiguration();
    }

    public void setAnzeige(Anzeige a) {
        gui = a;
    }

    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGap(0, 300, Short.MAX_VALUE)
        );
    }
    
    public BufferedImage getImage() {
    	return bim;
    }

}
