/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ffeststeuerungneu;

import Diashow.DiashowVerwaltung;
import Bildquellen.InstagramBilder;
import Bildquellen.SnapchatBilder;
import bilderAuswahl.ThreadBilderAuswahl;
import Bildquellen.WhatsappBilder;
import Server.Server;
import bilderAuswahl.AnzeigeAuswahlbild;
import appium.Connector;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.*;
import javax.swing.border.Border;


import com.sun.java.swing.plaf.windows.WindowsTabbedPaneUI;

/**
 *
 * @author Rudi
 */
public class Anzeige extends JPanel {

    //int for Icons
    private static final int ACCEPT = 0;
    private static final int DECLINE = 1;
    private static final int ROTATELEFT = 2;
    private static final int ROTATERIGHT = 3;
    private static final int PAUSE = 4;
    private static final int START = 5;
    private static final int FEHLER = 6;
    private static final int EINGANG = 7;
    private static final int SETTINGS = 8;
    private static final int MONITOR = 9;
    private final String ICONPFAD;

    private static final int INSTAGRAM = 0;
    private static final int SNAPCHAT = 1;
    private static final int WHATSAPP = 2;

    //int for showing number of received messages
    private int snapchatBildZahl = 0;
    private int instagramBildZahl = 0;
    private int fileBildZahl = 0;
    private int bildZahl = 0;

    private DiashowVerwaltung diashowVerwaltung;
    private ThreadBilderAuswahl tba;

    //Threads to receive
    private Thread threadInstagram;
    private Thread threadSnapchat;
    private Thread threadWhatsapp;
    private Thread threadWhatsappListener;

    private final Props p;
    private boolean fertig = false;
    private boolean pause = false;

    private Server server;
    
    private String meldung;

    private Border buttonBorder;
    private Border whiteBorder;
    private final ImageIcon icon[] = new ImageIcon[10];

    private static SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss");

    /**
     * Creates new form Anzeige
     *
     * @param f Frame
     */
    public Anzeige(frame f) {
        p = new Props();
        initDirectories(p.getInfo("ffestData"), p.getInfo("instagram"), p.getInfo("snapchat"));
        ICONPFAD = p.getInfo("resources");
        //Icons are read
        initIcon();
        //Classes get initialised
        initClasses();
        //Graphics get initialised
        initGraphic();

        //starts show on 2nd screen
        diashowVerwaltung.start();

        //sets Touchoptimized tabsize
        tabbedPane.setUI(new MyTabUI());
        //initialising has finished
        fertig = true;
        
    }

    public void setLogAnzeige() {
        Log.setAnzeige(this);
        
    }

    private void initClasses() {

        this.setBackground(Color.white);
        buttonBorder = BorderFactory.createRaisedSoftBevelBorder();
        whiteBorder = BorderFactory.createEmptyBorder(0, 10, 0, 10);

        
        diashowVerwaltung = new DiashowVerwaltung(Integer.valueOf(p.getInfo("screen")));
        auswahlbild1 = new AnzeigeAuswahlbild(getPfad(), p.getInfo("resources"), this);

        tba = new ThreadBilderAuswahl(this);
    }

    public void sleepThreads() {
        try {
            Thread.sleep(500);
        } catch (InterruptedException ex) {
            Logger.getLogger(Anzeige.class.getName()).log(Level.SEVERE, null, ex);
            Log.setError(ex, "Class: Anzeige. Sleepthreads failed");
        }
    }

    //Überprüft ob Ordner/Pfad vorhanden, erstellt ihn zur Not
    private boolean checkDir(String dirName) {
        File stats = new File(dirName);
        if (stats.exists() && stats.isDirectory()) // Überprüfen, ob es den Ordner gibt
        {
            Log.setInfo("Directory exists: " + dirName);
            return true;
        } else {
            Log.setDebug("Directory missing: " + dirName);
            return stats.mkdirs(); // Erstellen des Ordners
        }
    }

    //checks if all directories exist
    public void initDirectories(String pfad, String instagram, String snapchat) {

        checkDir(instagram);
        checkDir(snapchat);
        checkDir(pfad);
        checkDir(pfad + "archiv");
        checkDir(pfad + "log");
        checkDir(pfad + "archiv\\gut");
        checkDir(pfad + "archiv\\müll");

        Calendar cal = Calendar.getInstance();
        SimpleDateFormat sdf = new SimpleDateFormat("HH_mm_ss");

        checkDir(pfad + "archiv\\müll\\" + sdf.format(cal.getTime()));
        checkDir(pfad + "archiv\\gut\\" + sdf.format(cal.getTime()));

        Log.setProps(pfad);
    }

    /**
     * Gives new Image to the Diasho
     *
     * @param bim Image for Show
     */
    public void uebergebeBild(BufferedImage bim) {
        diashowVerwaltung.neuesBild(bim);
    }

    /**
     *
     * @return Pfad o ffestdata
     */
    public String getPfad() {
        return p.getInfo("ffestData");
//        return "C:\\";
    }

    /**
     * initialises Icons
     */
    private void initIcon() {
        icon[ACCEPT] = new ImageIcon(ICONPFAD + "accept.png");
        icon[DECLINE] = new ImageIcon(ICONPFAD + "decline.png");
        icon[ROTATERIGHT] = new ImageIcon(ICONPFAD + "rotateRight.png");
        icon[ROTATELEFT] = new ImageIcon(ICONPFAD + "rotateLeft.png");
        icon[PAUSE] = new ImageIcon(ICONPFAD + "pause.png");
        icon[START] = new ImageIcon(ICONPFAD + "start.png");
        icon[FEHLER] = new ImageIcon(ICONPFAD + "fehler.png");
        icon[EINGANG] = new ImageIcon(ICONPFAD + "eingang.png");
        icon[SETTINGS] = new ImageIcon(ICONPFAD + "settings.png");
        icon[MONITOR] = new ImageIcon(ICONPFAD + "monitor.png");

//        
//        icon[DECLINE] = new ImageIcon(this.getClass().getResource(ICONPFAD + "decline.png"));
//        icon[ROTATERIGHT] = new ImageIcon(this.getClass().getResource(ICONPFAD + "rotateRight.png"));
//        icon[ROTATELEFT] = new ImageIcon(this.getClass().getResource(ICONPFAD + "rotateLeft.png"));
//        icon[PAUSE] = new ImageIcon(this.getClass().getResource(ICONPFAD + "pause.png"));
//        icon[START] = new ImageIcon(this.getClass().getResource(ICONPFAD + "start.png"));
//        icon[FEHLER] = new ImageIcon(this.getClass().getResource(ICONPFAD + "fehler.png"));
//        icon[EINGANG] = new ImageIcon(this.getClass().getResource(ICONPFAD + "eingang.png"));
//        icon[SETTINGS] = new ImageIcon(this.getClass().getResource(ICONPFAD + "settings.png"));
//        icon[MONITOR] = new ImageIcon(this.getClass().getResource(ICONPFAD + "monitor.png"));

        scaleIcon();
    }

    /**
     * Scales Icons
     */
    private void scaleIcon() {
        for (int i = 0; i < FEHLER; i++) {
            icon[i].setImage(icon[i].getImage().getScaledInstance(100, 100, Image.SCALE_DEFAULT));
        }

        //TabIcons are smaller
        for (int i = FEHLER; i < icon.length; i++) {
            icon[i].setImage(icon[i].getImage().getScaledInstance(25, 25, Image.SCALE_DEFAULT));
        }

    }

    @Override
    /**
     * sets sizes of Components new
     */
    public void repaint() {
        if (fertig) {

//            
//            this.textareaLog.setPreferredSize(new Dimension(this.getWidth(), (int) (this.getHeight() * 0.6)));
            tabbedPane.setPreferredSize(new Dimension(this.getWidth(), this.getHeight()));
            auswahlbild1.setPreferredSize(new Dimension(this.getWidth(), (int) ((this.getHeight() - 210))));

            buttonDecline.setPreferredSize(new Dimension((int) (this.getWidth() / 4.5), 125));
            buttonAccept.setPreferredSize(new Dimension((int) (this.getWidth() / 4.5), 125));
            buttonRotateLeft.setPreferredSize(new Dimension((int) (this.getWidth() / 4.5), 125));
            buttonRotateRight.setPreferredSize(new Dimension((int) (this.getWidth() / 4.5), 125));

            this.buttonsEinstellungen.setPreferredSize(new Dimension(this.getWidth(), (int) (this.getHeight() * 0.25)));
            this.panelSliderEinstellungen.setPreferredSize(new Dimension(this.getWidth(), (int) (this.getHeight() * 0.4)));

            this.buttonNächstesBild.setPreferredSize(new Dimension((int) (buttonsEinstellungen.getWidth() * 0.25), buttonsEinstellungen.getHeight()));
            this.buttonPause.setPreferredSize(new Dimension((int) (buttonsEinstellungen.getWidth() * 0.25), buttonsEinstellungen.getHeight()));

            this.textareaLog.setPreferredSize(new Dimension(this.getWidth(), (int) (this.getHeight() * 0.6)));

        }
    }

    /**
     * initialises Graphic components and adds them to Panel
     */
    private void initGraphic() {
        initComponents();
        initSlider();
        initButtons();
        initMenuband();
        initEinstellungen();
        initMonitor();

        auswahlbild1.setAnzeige(this);

        panelBildereingang.setLayout(new BorderLayout());
        panelBildereingang.add(auswahlbild1, BorderLayout.NORTH);
        panelBildereingang.add(panelButtons, BorderLayout.SOUTH);

        panelMonitor.setVisible(true);
        tabbedPane.addTab("   Bildereingang (" + bildZahl + ")", panelBildereingang);
        tabbedPane.addTab("   Diashow", panelDiashow);
        tabbedPane.addTab("   Monitor", panelMonitor);

        tabbedPane.setIconAt(0, icon[EINGANG]);
        tabbedPane.setIconAt(1, icon[SETTINGS]);
        tabbedPane.setIconAt(2, icon[MONITOR]);

        this.add(tabbedPane);
        validate();
        repaint();
    }

    /**
     * adds/creates Settingswindow
     */
    private void initEinstellungen() {

        this.labelAnzahlbilder.setFont(new java.awt.Font("Tahoma", 4, 25));
        this.labelBilddauer.setFont(new java.awt.Font("Tahoma", 4, 25));
        this.sliderAnzahlbilder.setFont(new java.awt.Font("Tahoma", 4, 20));
        this.sliderBilddauer.setFont(new java.awt.Font("Tahoma", 4, 20));

        panelThreadsControl.setLayout(new GridLayout(2, 5));
        panelThreadsControl.add(new JLabel(""));
        panelThreadsControl.add(new JLabel(""));
        panelThreadsControl.add(new JLabel(""));
        panelThreadsControl.add(new JLabel(""));
        panelThreadsControl.add(new JLabel(""));
        panelThreadsControl.add(buttonInstagram);
        panelThreadsControl.add(buttonSnapchat);
        panelThreadsControl.add(buttonFile);
        panelThreadsControl.add(buttonWhatsappListener);
        panelThreadsControl.add(buttonServer);

        panelLabel.setLayout(new BorderLayout());

        buttonsEinstellungen.setLayout(new GridLayout(1, 3));
        buttonsEinstellungen.add(buttonPause, BorderLayout.WEST);
        buttonsEinstellungen.add(panelLabel);
        panelLabel.add(labelPause, BorderLayout.CENTER);
        labelPause.setIcon(icon[DECLINE]);
        buttonsEinstellungen.add(this.buttonNächstesBild, BorderLayout.EAST);
        labelPause.setVisible(false);

//        panelSliderBilddauer.setBorder(whiteBorder);
//        panelSliderBildanzahl.setBorder(whiteBorder);
        panelSliderBilddauer.setLayout(new BorderLayout());
        panelSliderBildanzahl.setLayout(new BorderLayout());

        panelSliderBilddauer.add(this.labelBilddauer, BorderLayout.CENTER);
        panelSliderBilddauer.add(sliderBilddauer, BorderLayout.SOUTH);

        panelSliderBildanzahl.add(this.labelAnzahlbilder, BorderLayout.CENTER);
        panelSliderBildanzahl.add(sliderAnzahlbilder, BorderLayout.SOUTH);

        panelDiashow.setLayout(new GridLayout(4, 1));
        panelDiashow.add(this.buttonsEinstellungen);
        panelDiashow.add(panelThreadsControl);
        panelDiashow.add(panelSliderBilddauer);
        panelDiashow.add(panelSliderBildanzahl);

    }

    /**
     * adds Buttons of image Entry (Accept etc.)
     */
    private void initMenuband() {
        panelButtons.setLayout(new GridLayout(1, 4));
        panelButtons.add(buttonAccept);
        panelButtons.add(buttonRotateLeft);
        panelButtons.add(buttonRotateRight);
        panelButtons.add(buttonDecline);
    }

    /**
     * initialises Graphical Components
     */
    private void initComponents() {
        tabbedPane = new JTabbedPane();
        server = new Server(this);
//        tabbedPane.setFont(new java.awt.Font("Tahoma", 4, 12));
        panelBildereingang = new JPanel();
        panelDiashow = new JPanel();
        panelButtons = new JPanel();
        buttonsEinstellungen = new JPanel();
        panelSliderEinstellungen = new JPanel();
        panelThreadsControl = new JPanel();
        panelSliderBilddauer = new JPanel();
        panelSliderBildanzahl = new JPanel();
        panelLog = new JPanel();
        panelMonitor = new JPanel();
        panelMonitorInfo = new JPanel();
        panelLabel = new JPanel();

        labelBilddauer = new JLabel("Anzeigedauer Bild");
        labelAnzahlbilder = new JLabel("Anzahl Bilder");
        labelPause = new JLabel("Pause");
        labelInstagram = new JLabel("Instagram: 0");
        labelSnapchat = new JLabel("Snapchat: 0");
        labelFile = new JLabel("File: 0");

        buttonAccept = new JButton(icon[ACCEPT]);
        buttonDecline = new JButton(icon[DECLINE]);
        buttonRotateRight = new JButton(icon[ROTATERIGHT]);
        buttonRotateLeft = new JButton(icon[ROTATELEFT]);
        buttonPause = new JButton(icon[PAUSE]);

        buttonInstagram = new JButton("Instagram");
        buttonSnapchat = new JButton("Snapchat");
        buttonFile = new JButton("Whatsapp");
        buttonWhatsappListener = new JButton("Listener");
        buttonServer = new JButton("Server");
        buttonResetAlarm = new JButton("ResetAlarm");
        sliderBilddauer = new JSlider();

        buttonNächstesBild = new JButton();
        sliderAnzahlbilder = new JSlider();

        textareaLog = new JTextArea("  ");
    }

    /**
     * creates Slider and sets properties
     */
    private void initSlider() {

        sliderAnzahlbilder.setMajorTickSpacing(5);
        sliderAnzahlbilder.setMaximum(30);
        sliderAnzahlbilder.setMinorTickSpacing(1);
        sliderAnzahlbilder.setPaintLabels(true);
        sliderAnzahlbilder.setPaintTicks(true);
        sliderAnzahlbilder.setSnapToTicks(true);
        sliderAnzahlbilder.setValue(10);
        sliderAnzahlbilder.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        sliderAnzahlbilder.setEnabled(false);

        sliderBilddauer.setMajorTickSpacing(5);
        sliderBilddauer.setMaximum(30);
        sliderBilddauer.setMinorTickSpacing(1);
        sliderBilddauer.setPaintLabels(true);
        sliderBilddauer.setPaintTicks(true);
        sliderBilddauer.setSnapToTicks(true);
        sliderBilddauer.setValue(15);
        sliderBilddauer.setExtent(1);
        sliderBilddauer.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        sliderBilddauer.addChangeListener((javax.swing.event.ChangeEvent evt) -> {
            actionBildDauerStateChanged(evt);
        });
    }

    /**
     * adds path of a new Image
     *
     * @param pfad Link to the new Image
     */
    public void addPath(String pfad) {
        this.auswahlbild1.addPath(pfad);
        bildZahl++;
        setBildZahl();

    }

    /**
     * adds Buttons and properties
     */
    private void initButtons() {

        buttonAccept.setText("Accept");
        buttonDecline.setText("Decline");
        buttonRotateRight.setText("Rechts drehen");
        buttonRotateLeft.setText("Links drehen");
        buttonNächstesBild.setText("Nächstes Bild");
        buttonResetAlarm.setText("Reset Alarm");
        buttonPause.setText("   Pause");

        buttonAccept.setFont(new java.awt.Font("Tahoma", 4, 18));
        buttonDecline.setFont(new java.awt.Font("Tahoma", 4, 18));
        buttonRotateRight.setFont(new java.awt.Font("Tahoma", 4, 18));
        buttonRotateLeft.setFont(new java.awt.Font("Tahoma", 4, 18));
        buttonNächstesBild.setFont(new java.awt.Font("Tahoma", 4, 25));
        buttonResetAlarm.setFont(new java.awt.Font("Tahoma", 4, 25));
        buttonPause.setFont(new java.awt.Font("Tahoma", 4, 25));
        buttonInstagram.setFont(new java.awt.Font("Tahoma", 4, 25));
        buttonFile.setFont(new java.awt.Font("Tahoma", 4, 25));
        buttonWhatsappListener.setFont(new java.awt.Font("Tahoma", 4, 25));
        buttonSnapchat.setFont(new java.awt.Font("Tahoma", 4, 25));

        buttonSnapchat.addActionListener(this::actionSnapThreadActionPerformed);
        buttonInstagram.addActionListener(this::actionInstaThreadActionPerformed);
        buttonFile.addActionListener(this::actionWhatsappThreadActionPerformed);
        buttonPause.addActionListener(this::actionButtonPauseActionPerformed);
        buttonNächstesBild.addActionListener(this::actionNächstesBildActionPerformed);
        buttonAccept.addActionListener((evt) -> this.actionAcceptImageActionPerformed(evt));
        buttonDecline.addActionListener(this::actionDeclineImageActionPerformed);  
        buttonRotateRight.addActionListener(this::actionRotateImageRechtsActionPerformed);
        buttonRotateLeft.addActionListener((evt) -> this.actionRotateImageLinksActionPerformed(evt));
        buttonResetAlarm.addActionListener((evt) -> this.actionResetAlarmActionPerformed(evt));
        buttonWhatsappListener.addActionListener((evt) -> this.actionWhatsappListenerActionPerformed(evt));
        buttonServer.addActionListener((evt) -> this.actionStartServerPerformed(evt));
        
        buttonResetAlarm.setEnabled(false);

        buttonSnapchat.setBackground(Color.red);
        buttonInstagram.setBackground(Color.red);
        buttonFile.setBackground(Color.red);
        buttonWhatsappListener.setBackground(Color.red);

    }

    /**
     * creates MonitorPanel
     */
    private void initMonitor() {

        labelSnapchat.setFont(new java.awt.Font("Tahoma", 4, 25));
        labelFile.setFont(new java.awt.Font("Tahoma", 4, 25));
        labelInstagram.setFont(new java.awt.Font("Tahoma", 4, 25));

        buttonResetAlarm.setFont(new java.awt.Font("Tahoma", 4, 25));

        panelMonitor.setLayout(new BorderLayout());
        this.panelMonitorInfo.setLayout(new GridLayout(2, 4));
        this.panelMonitorInfo.add(new JLabel(""));
        this.panelMonitorInfo.add(new JLabel(""));
        this.panelMonitorInfo.add(new JLabel(""));
        this.panelMonitorInfo.add(new JLabel(""));
        this.panelMonitorInfo.add(labelSnapchat);
        panelMonitorInfo.add(labelInstagram);
        panelMonitorInfo.add(labelFile);
        panelMonitorInfo.add(buttonResetAlarm);

        this.panelLog.add(textareaLog);

        panelMonitor.add(panelMonitorInfo, BorderLayout.NORTH);
        panelMonitor.add(panelLog, BorderLayout.SOUTH);

    }

    /**
     * Action when Snapchat button pressed (starts/stops snapchat thread)
     *
     * @param evt not used
     */
    private void actionSnapThreadActionPerformed(java.awt.event.ActionEvent evt) {

        if (threadSnapchat != null && threadSnapchat.isAlive()) {
            meldung = "SnapchatThread BEENDEN?";
        } else {
            meldung = "SnapchatThread starten?";
        }

        int n = JOptionPane.showConfirmDialog(
                this,
                meldung,
                "SelfieGrabber",
                JOptionPane.YES_NO_OPTION);

        if (n == 0) {
            if (threadSnapchat != null && threadSnapchat.isAlive()) {
                threadSnapchat.interrupt();
                this.buttonSnapchat.setBackground(Color.RED);
                diashowVerwaltung.setOnline(SNAPCHAT, false);
            } else {
                threadSnapchat = new SnapchatBilder(tba, p.getInfo("snapchat"));
                threadSnapchat.start();
                this.buttonSnapchat.setBackground(Color.GREEN);
                diashowVerwaltung.setOnline(SNAPCHAT, true);
            }
        }
    }

    private void actionStartServerPerformed(java.awt.event.ActionEvent evt){
        
        if (server.getStatus()) {
            meldung = "Server BEENDEN?";
        } else {
            meldung = "Server starten?";
        }

        int n = JOptionPane.showConfirmDialog(
                this,
                meldung,
                "SelfieGrabber",
                JOptionPane.YES_NO_OPTION);

        if (n == 0) {
            if (server.getStatus()) {
                server.stopServer();
                this.buttonServer.setBackground(Color.RED);
            } else {
                server.startServer();
                this.buttonServer.setBackground(Color.GREEN);
            }
        }
        
    }
    
    /**
     * Action when insta button pressed (starts/stops insta thread)
     *
     * @param evt not used
     */
    private void actionInstaThreadActionPerformed(java.awt.event.ActionEvent evt) {

        if (threadInstagram != null && threadInstagram.isAlive()) {
            meldung = "InstagramThread BEENDEN?";
        } else {
            meldung = "InstagramThread starten?";
        }

        int n = JOptionPane.showConfirmDialog(
                this,
                meldung,
                "SelfieGrabber",
                JOptionPane.YES_NO_OPTION);

        if (n == 0) {
            if (threadInstagram != null && threadInstagram.isAlive()) {
                threadInstagram.interrupt();
                this.buttonInstagram.setBackground(Color.RED);
                diashowVerwaltung.setOnline(INSTAGRAM, false);
            } else {
                threadInstagram = new InstagramBilder(tba, p.getInfo("instagram"));
                threadInstagram.start();
                this.buttonInstagram.setBackground(Color.GREEN);
                diashowVerwaltung.setOnline(INSTAGRAM, true);
            }
        }
    }

    /**
     * Action when file button pressed (starts/stops file thread)
     *
     * @param evt not used
     */
    private void actionWhatsappThreadActionPerformed(java.awt.event.ActionEvent evt) {

        if (threadWhatsapp != null && threadWhatsapp.isAlive()) {
            meldung = "FileThread BEENDEN?";
        } else {
            meldung = "FileThread starten?";
        }

        int n = JOptionPane.showConfirmDialog(
                this,
                meldung,
                "SelfieGrabber",
                JOptionPane.YES_NO_OPTION);

        if (n == 0) {
            if (threadWhatsapp != null && threadWhatsapp.isAlive()) {
                threadWhatsapp.interrupt();
                this.buttonFile.setBackground(Color.RED);
                diashowVerwaltung.setOnline(WHATSAPP, false);
            } else {
                threadWhatsapp = new WhatsappBilder(tba, p.getInfo("whatsapp"));
                threadWhatsapp.start();
                this.buttonFile.setBackground(Color.GREEN);
                diashowVerwaltung.setOnline(WHATSAPP, true);
            }
        } 
    }

    /**
     * Accept button pressed -> adds image to show
     *
     * @param evt not used
     */
    private void actionAcceptImageActionPerformed(java.awt.event.ActionEvent evt) {
        auswahlbild1.verarbeite(true);
        bildZahl--;
        setBildZahl();
        this.labelFile.setText("File: " + Log.getFile());
        this.labelSnapchat.setText("Snapchat: " + Log.getSnapchat());
        this.labelInstagram.setText("Instagram: " + Log.getInstagram());
    }

    /**
     * rotate Rigth button pressed -> rotates image
     *
     * @param evt not used
     */
    private void actionRotateImageRechtsActionPerformed(java.awt.event.ActionEvent evt) {
        auswahlbild1.rotate(90);
    }

    /**
     * decline button pressed -> saves images in garbage
     *
     * @param evt
     */
    private void actionDeclineImageActionPerformed(java.awt.event.ActionEvent evt) {
        auswahlbild1.verarbeite(false);
        bildZahl--;
        setBildZahl();
    }

    /**
     * button Pause pressed -> pausses show, sets label pause visible
     *
     * @param evt
     */
    private void actionButtonPauseActionPerformed(java.awt.event.ActionEvent evt) {

        if (pause != true) {
            labelPause.setVisible(true);
            buttonPause.setIcon(icon[START]);
            buttonPause.setText("    Start ");
            pause = true;
        } else {
            labelPause.setVisible(false);
            buttonPause.setIcon(icon[PAUSE]);
            buttonPause.setText("   Pause");
            pause = false;
        }
        repaint();
        diashowVerwaltung.pause();

        this.validate();

    }

    private void actionBildDauerStateChanged(javax.swing.event.ChangeEvent evt) {
        if (sliderBilddauer.getValue() < 1) {
            sliderBilddauer.setValue(1);
        }
        diashowVerwaltung.setTime(sliderBilddauer.getValue());
    }

    private void actionNächstesBildActionPerformed(java.awt.event.ActionEvent evt) {
        diashowVerwaltung.weiter();
    }

    private void actionRotateImageLinksActionPerformed(java.awt.event.ActionEvent evt) {
        auswahlbild1.rotate(-90);
    }

    private void actionResetAlarmActionPerformed(java.awt.event.ActionEvent evt) {
        buttonResetAlarm.setEnabled(false);

        this.tabbedPane.setIconAt(2, icon[MONITOR]);
        this.tabbedPane.setForegroundAt(2, Color.black);
    }
    
    private void actionWhatsappListenerActionPerformed(java.awt.event.ActionEvent evt) {
        if (threadWhatsappListener != null && threadWhatsappListener.isAlive()) {
            meldung = "ListenerThread BEENDEN?";
        } else {
            meldung = "ListenerThread starten?";
        }

        int n = JOptionPane.showConfirmDialog(
                this,
                meldung,
                "Listener",
                JOptionPane.YES_NO_OPTION);

        if (n == 0) {
            if (threadWhatsappListener != null && threadWhatsappListener.isAlive()) {
                threadWhatsappListener.interrupt();
                this.buttonWhatsappListener.setBackground(Color.RED);
            } else {
                threadWhatsappListener = new Connector();
                threadWhatsappListener.start();
                this.buttonWhatsappListener.setBackground(Color.GREEN);
            }
        }
        
        
    }
    

    public void setButtons(boolean status) {
        buttonAccept.setEnabled(status);
        buttonDecline.setEnabled(status);
        buttonRotateLeft.setEnabled(status);
        buttonRotateRight.setEnabled(status);
    }

    public void setLogData(String s) {
        textareaLog.append("---------------------\n" + s + "\n");

        buttonResetAlarm.setEnabled(true);

        this.tabbedPane.setForegroundAt(2, Color.red);
        this.tabbedPane.setIconAt(2, this.icon[FEHLER]);
        this.tabbedPane.validate();
    }

    public void setSnapchatNumber(int s) {
        this.snapchatBildZahl++;
        this.labelSnapchat.setText("Snapchat: " + snapchatBildZahl);
    }

    public void setInstagramNumber(int s) {
        this.instagramBildZahl++;
        this.labelSnapchat.setText("Instagram: " + instagramBildZahl);
    }

    public void setFileNumber() {
        this.fileBildZahl++;
        this.labelSnapchat.setText("File: " + fileBildZahl);
    }

    public void setBildZahl() {
        tabbedPane.setTitleAt(0, "   Bildereingang (" + this.bildZahl + ")");
    }
    
    //returns aktuelles Auswahlbild f�r server
    public BufferedImage getBild() {
    	return auswahlbild1.getImage();
    }
    
    public int getNumberOfImages() {
    	return bildZahl;
    }
    
    public void clickAccept() {
    	ActionEvent click = new ActionEvent(this.buttonAccept, (int) System.currentTimeMillis(), "");
    	this.actionAcceptImageActionPerformed(click); 
    }
    
    public void clickDecline() {
    	ActionEvent click = new ActionEvent(this.buttonDecline, (int) System.currentTimeMillis(), "");
    	this.actionDeclineImageActionPerformed(click); 
    }

    // Variables declaration - do not modify  
    private JTabbedPane tabbedPane;
    private JPanel panelBildereingang;
    private JPanel panelDiashow;
    private JPanel panelButtons;
    private JPanel buttonsEinstellungen;
    private JPanel panelSliderEinstellungen;
    private JPanel panelThreadsControl;
    private JPanel panelSliderBilddauer;
    private JPanel panelSliderBildanzahl;
    private JPanel panelMonitor;
    private JPanel panelLog;
    private JPanel panelMonitorInfo;
    private JPanel panelLabel;

    private JButton buttonAccept;
    private JButton buttonDecline;
    private JButton buttonNächstesBild;
    private JButton buttonRotateLeft;
    private JButton buttonRotateRight;
    private JButton buttonInstagram;
    private JButton buttonSnapchat;
    private JButton buttonWhatsappListener;
    private JButton buttonFile;
    private JButton buttonServer;
    private JButton buttonResetAlarm;
    private JButton buttonPause;

    private AnzeigeAuswahlbild auswahlbild1;
    private JLabel labelAnzahlbilder;
    private JLabel labelBilddauer;
    private JLabel labelPause;
    private JLabel labelSnapchat;
    private JLabel labelInstagram;
    private JLabel labelFile;

    private JTextArea textareaLog;

    private JSlider sliderAnzahlbilder;
    private JSlider sliderBilddauer;

    public class MyTabUI extends WindowsTabbedPaneUI {

        @Override
        protected Insets getTabInsets(int tabPlacement, int tabIndex) {
            return new Insets(0, 0, 50, 200);
        }
    }

}
